#!/usr/bin/env python
# coding=utf-8

import ldap
import sys
import httplib
import json
import os
from socket import getfqdn
from subprocess import check_output
from base64 import b64decode as dd

class PasswordIncorrect(Exception):
	pass
class NotAllowed(Exception):
	pass

class LDAP():
	""" Returns LDAP class """

	def __init__(self, uid):
		self.uid = uid
		self.cp = False
		base = ""
		for dc in getfqdn().split('.')[1:]:
			base += "dc=%s," % dc

		self.server = "ldap://c0"
		self.base = base[:-1]

		try:
			conn = ldap.initialize(self.server)

		except ldap.LDAPError, e:
			sys.stderr.write("Fatal Error.n")
			raise

		self.search = "uid=%s" %uid

		self.conn = conn


	def whoami(self):
		return self.conn.search_s(self.base, ldap.SCOPE_SUBTREE, self.search)

	def uidNumber(self):
		return self.whoami()[0][1]['uidNumber'][0]

	def gidNumber(self):
		return self.whoami()[0][1]['gidNumber'][0]

	def cn(self):
		return self.whoami()[1]['cn'][0]


	def passwd(self, olpassword, newpassword):
		conn = httplib.HTTPConnection("c0", 3032)
		url = "%s%s/%s/%s%s" % (dd('L2xkYXBwYXNzd2Qv'), self.uid, olpassword, newpassword, dd('P2tleT1wQ1RDVjE3Y3dBQUo4czQ5NzRQVEczMFo4NDQ2d3ZmMg=='))
		conn.request("POST", url)
		response = conn.getresponse()
		d = response.read()

		data = json.loads(d)

		if data['success']:
			self.cp = True
			return True
		else:
			if data['reason'].rstrip() == "Old password incorrect":
				raise PasswordIncorrect
				return False
			else:
				raise NotAllowed
				raise False
		